//
// PCM(JR) decoder
//
//                     ---------
//    RS    --> RA2/AN2|1    18| RA1/AN1 -->
//          <-- RA3/AN3|2    17| RA0/AN0 -->
//          <-- RA4/AN4|3    16| OSC1
//          /-- RA5    |4    15| OSC2
//                  GND|5    14| +5V
//          <-- RB0    |6    13| RB7/AN6 -->
//          <-- RB1    |7    12| RB6/AN5 -->
//          <-- RB2    |8    11| RB5     --> TX
//          <-- RB3    |9    10| RB4     -->
//                     ---------



//#define debug	1


#pragma config  = 0x3F50


//-----------------------------------
#define ERROR			0
#define TRUE			1
#define FALSE			0
#define	HIGH			1
#define LOW				0

//-----------------------------------
#pragma bit FET3 @ PORTB.7		//FET3 drive port
#pragma bit FET2 @ PORTB.5		//FET2 drive port
#pragma bit FET1 @ PORTB.4		//FET1 drive port

//-----------------------------------
#pragma bit RA0 @ PORTA.0
#pragma bit RA1 @ PORTA.1
#pragma bit RA2 @ PORTA.2
#pragma bit RA3 @ PORTA.3
#pragma bit RA4 @ PORTA.4
#pragma bit RA5 @ PORTA.5
#pragma bit RA6 @ PORTA.6

#pragma bit RB0 @ PORTB.0
#pragma bit RB1 @ PORTB.1
#pragma bit RB2 @ PORTB.2
#pragma bit RB3 @ PORTB.3
#pragma bit RB4 @ PORTB.4
#pragma bit RB5 @ PORTB.5


//-----------------------------------------------
void	delay_ms( void );
void	GetPeriod( void );
void	InitUSART( void );

//-----------------------------------------------global
uns16			millisec;

unsigned int	pulse_width;


//----------------------------------------------------

void GetPeriod(void)
{
	
	if( RA2==LOW ){				// RA2=LOW
		while ( RA2==LOW ){}
	}
	else{						// RA2=HIGH
		while ( RA2==HIGH ){}
	}

	pulse_width = TMR0;		// HIGH pulse width
	TMR0 = 0;


}

//----------------------------------------------------
void InitUSART( void )
{
	BRGH	= 1;		// high speed serial port mode
	SPBRG	= 8;		// Set 57600 baud for 8MHz oscillator
//	SPBRG	= 51;		// Set 9600 baud for 8MHz oscillator
//	SPBRG	= 25;		// Set 19200 baud for 8MHz oscillator
	SYNC	= 0;		// Clear SYNC bit ; Set_Async_Mode;
	SPEN	= 1;		// Set serial port enable
	TX9		= 0;		// 8-bit transmissions
	TXEN	= 1;		// Enable transmission
	RCIE	= 0;		// Rx interrupts fisable
	RX9		= 0;		// 8-bit receptions
	CREN	= 0;		// disable reception
}

//----------------------------------------------------
void main(void)
{

	unsigned int tmp;


//------device setting
	OSCCON	= 0x70;		// internal OSC = 8MHz
	PORTA	= 0x00;
	PORTB	= 0x20;		// RB5 = HIGH
	ANSEL	= 0x00;		//AN6,5,4,3,2,1,0 = Digital 
//	ADCON0	= 0xC0;		//
//	ADCON1	= 0x00;		//Left justified, ADCS2=1, reference=Vdd/Vss
	CMCON	= 0x07;		//Comparator setting Not use
 	OPTION	= 0x84;		//prescaler 1/32
 	TMR0	= 0;
 	TRISA	= 0x04;		// port A  7,6,5,4,3,  1,0=output  2=input
 	TRISB	= 0x00;		// port B  7,6,5,4,3,2,1,0=output
//	ADON	= 1;

RB0=HIGH;
RB1=HIGH;
RB2=HIGH;
RB3=HIGH;


//------------
	InitUSART();

//------------
		// Waiting for 1
		while ( RA2==LOW ){}
		// Waiting for 0
		while ( RA2==HIGH ){}
		TMR0 = 0;
//------------
	while (1)
	{

		GetPeriod();

		TXREG = pulse_width;		// serial out LOW period
		while( TXIF==0 ){			// wait for serial register to be sent
		}



	}	// end of while

}	// end of main

